"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultClientProps = exports.defaultHttpReqConfig = exports.defaultCacheStore = void 0;
var response_parser_1 = require("./response-parser");
var request_body_serializer_1 = require("./request-body-serializer");
var cache_1 = require("../cache");
var prefix_decorator_1 = require("../cache/prefix-decorator");
var enum_1 = require("../enum");
exports.defaultCacheStore = new cache_1.HttpInMemoryCacheStore();
exports.defaultHttpReqConfig = {
    baseUrl: '',
    responseParser: response_parser_1.httpResponseParser,
    requestBodySerializer: request_body_serializer_1.serializeRequestBody,
    reqOptions: {
        headers: {
            'Content-Type': 'application/json',
        },
        method: enum_1.HttpMethod.Get,
    },
    cache: new cache_1.HttpCacheService(new prefix_decorator_1.HttpCacheStorePrefixDecorator(exports.defaultCacheStore)),
};
exports.defaultClientProps = {
    config: exports.defaultHttpReqConfig,
};
